/* ESP32_blink_control
 *  
 * Felváltva villogtatunk két LED-et (GPIO23 és GPIO22). 
 * A villogás sebessége GPIO21 bemenetre kötött nyomógombtól függ.
 * Felengedett nyomógomb esetén 500 ms-onként váltunk.
 * Lenyomott gomb esetén 100 ms-onként váltunk.
 * 
 * Arduino 1.8.15 és ESP32 2.0.0 kiadással tesztelve
 */
#define RED_LED   23
#define GREEN_LED 22
#define BUTTON    21

void setup() {
  pinMode(RED_LED,OUTPUT);       // legyen kimenet
  pinMode(GREEN_LED,OUTPUT);     // legyen kimenet
  pinMode(BUTTON,INPUT_PULLUP);  // legyen bemenet, belső felhúzással
}

void loop() {
  boolean sw;
  sw = digitalRead(BUTTON);      // Belovassuk a nyomógomb állapotát
  digitalWrite(RED_LED,HIGH);    // A piros LED világít
  digitalWrite(GREEN_LED,LOW);   // A zöld LED nem világít
  if(sw == HIGH) delay(500);     // Felengedett gomb esetén HIGH állapot van
  else delay(100);               // egyébként 100 ms késleltetés kell
  digitalWrite(RED_LED,LOW);     // A piros LED nem világít
  digitalWrite(GREEN_LED,HIGH);  // A zöld LED világít    
  if(sw == HIGH) delay(500);     // Felengedett gomb esetén 500ms késleltetés
  else delay(100);               // egyébként 100 ms késleltetés kell
} 
