/* ESP32_interrupt.ino

   Nyomógombbal kiváltott megszakítás és volatile változó
   használatának bemutatása.
   A beépített BOOT nyomógomb (GPIO0) lenyomásakor megszakításokat keltünk,
   s a megszakítást kiszolgáló blink() függvényben a state logikai
   változó állapotát átbillentjük.

   A loop függvényben a beépített LED (GPIO2) állapotát a state
   változó pillanatnyi állapotához igazítjuk.

*/
volatile byte state = LOW;

void setup() {
  pinMode(LED_BUILTIN, OUTPUT);  // LED_BUILTIN esetünkben GPIO2
  attachInterrupt(digitalPinToInterrupt(0), blink, FALLING);
}

void loop() {
  digitalWrite(LED_BUILTIN, state);
}

void blink() {
  state = !state;  // change state at each interrupt
}
