/* ESP32_multitasking
 *  
 * Két LED-et (GPIO23 és GPIO22) különböző ütemben villogtatunk,
 * blokkoló várakozás (delay() függvény) használata nélkül. 
 * A piros LED 1000 ms-onként vált állapotot, a zöld LED pedig 
 * 5000 ms-onként. 
 * Mindig előre kiszámoljuk, és eltároljuk (redTime, greenTime változók), 
 * hogy mikor kerül sorra az adott esemény.
 * A loop() ciklusokban megnézzük, hogy mennyi az idő és 
 * összehasonlítjuk azt a feljegyzéseinkkel. Ha elérkezett az
 * előre kiszámolt idő, akkor végrehajtjuk a kívánt akciót és
 * új időpontot jelölünk ki.
 * 
 * Arduino 1.8.15 és ESP32 2.0.0 kiadással tesztelve
 */
#define RED_LED 23
#define GREEN_LED 22
uint32_t nowTime, redTime, greenTime;
boolean rState=LOW, gState=LOW;
 
void setup() {
  pinMode(RED_LED,OUTPUT);
  pinMode(GREEN_LED,OUTPUT);
  nowTime = millis();
  redTime = nowTime + 1000;
  greenTime = nowTime + 5000;
}

void loop() {
  nowTime = millis();
  if(nowTime > redTime) {
    rState = !rState;
    digitalWrite(RED_LED,rState);
    redTime += 1000;
  }
  if(nowTime > greenTime) {
    gState = !gState;
    digitalWrite(GREEN_LED,gState);
    greenTime += 5000;      
  }
}
